; graphics, animation

!ifdef INCLUDE_GFX !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_GFX = 1
}

!zn Gfx {

spellgfx:
!by ' ', ' '    ; 0, 1
!by CHAR_KING_COBRA ; 2 - King Cobra
!by CHAR_DIRE_WOLF  ; 3 - Dire Wolf
!by CHAR_GOBLIN ; 4 - Goblin
!by CHAR_CROCODILE  ; 5 - Crocodile
!by 't' ; 6 - Troll
!by CHAR_FAUN   ; 7 - Faun
!by 'l' ; 8 - Lion
!by CHAR_ELF    ; 9 - Elf
!by 'o' ; 10 - Orc
!by 'B' ; 11 - Bear
!by CHAR_GORILLA    ; 12 - Gorilla
!by CHAR_OGRE   ; 13 - Ogre
!by CHAR_HYDRA  ; 14 - Hydra
!by CHAR_RAT    ; 15 - Giant Rat
!by CHAR_GIANT  ; 16 - Giant
!by CHAR_HORSE  ; 17 - Horse
!by CHAR_UNICORN    ; 18 - Unicorn
!by CHAR_CENTAUR    ; 19 - Centaur
!by CHAR_PEGASUS    ; 20 - Pegasus
!by CHAR_GRYPHON    ; 21 - Gryphon
!by CHAR_MANTICORE  ; 22 - Manticore
!by CHAR_BAT    ; 23 - Bat
!by CHAR_DRAGON ; 24 - Green Dragon
!by CHAR_DRAGON ; 25 - Red Dragon
!by CHAR_DRAGON ; 26 - Golden Dragon
!by CHAR_HARPY  ; 27 - Harpy
!by CHAR_EAGLE  ; 28 - Eagle
!by CHAR_VAMPIRE    ; 29 - Vampire
!by CHAR_GHOST  ; 30 - Ghost
!by CHAR_SPECTRE    ; 31 - Spectre
!by CHAR_WRAITH ; 32 - Wraith
!by CHAR_SKELETON   ; 33 - Skeleton
!by CHAR_ZOMBIE ; 34 - Zombie
!by CHAR_GOOEY_BLOB ; 35 - Gooey Blob
!by CHAR_FIRE   ; 36 - Magic Fire
!by CHAR_WOOD   ; 37 - Magic Wood
!by CHAR_WOOD   ; 38 - Shadow Wood
!by CHAR_MAGIC_CASTLE   ; 39 - Magic Castle
!by CHAR_DARK_CITADEL   ; 40 - Dark Citadel
!by CHAR_WALL   ; 41 - Wall
; 42..49 - Wizard
!for .i, 0, 8 {
!by CHAR_WIZARD
}


; acoord = coordinate to flash
; y = frames
; x = end color
flash_anim:
    stx .flash_anim_ecolor
    sty .flash_anim_loops
    jsr print_setup_dst_area    ; TODO redundant?
    ldy acoord
    ldx tbl_area_i_to_screen,y
.flash_anim_loops = * + 1
    ldy #100
-   lda #1
    jsr delay
    lda colorram + POS_AREA,x
    clc
    adc #1
    and #7
    sta colorram + POS_AREA,x
    dey
    bne -
.flash_anim_ecolor = * + 1
    lda #0
    sta colorram + POS_AREA,x
    rts

; TODO improve and/or combine
.gfx_anim_all:
GFX_OFFS_POP = * - .gfx_anim_all
gfx_anim_pop:
!tx " .oOX", CHAR_RAY, "X", CHAR_RAY
LEN_gfx_anim_pop = * - gfx_anim_pop
GFX_OFFS_SPELL = * - .gfx_anim_all
gfx_anim_spell:
!tx " .oOOo."
LEN_gfx_anim_spell = * - gfx_anim_spell
GFX_OFFS_SPLAT = * - .gfx_anim_all
gfx_anim_splat:
!tx "0Oo."
LEN_gfx_anim_splat = * - gfx_anim_splat
GFX_OFFS_ATTACK = * - .gfx_anim_all
gfx_anim_attack:
!tx "X", CHAR_RAY, "X", CHAR_RAY
LEN_gfx_anim_attack = * - gfx_anim_attack
GFX_OFFS_BREATH = * - .gfx_anim_all
gfx_anim_breath:
!tx ".uwUWUwu"
LEN_gfx_anim_breath = * - gfx_anim_breath

tbl_gfx_anim_pos0:
!by GFX_OFFS_POP + LEN_gfx_anim_pop - 1
!by GFX_OFFS_SPELL + LEN_gfx_anim_spell - 1
!by GFX_OFFS_SPLAT + LEN_gfx_anim_splat - 1
!by GFX_OFFS_ATTACK + LEN_gfx_anim_attack - 1
!by GFX_OFFS_BREATH + LEN_gfx_anim_breath - 1
tbl_gfx_anim_pos1:
!by GFX_OFFS_POP - 1, GFX_OFFS_SPELL - 1, GFX_OFFS_SPLAT - 1, GFX_OFFS_ATTACK - 1
!by GFX_OFFS_BREATH - 1

GFX_ANIM_POP = 0
GFX_ANIM_SPELL = 1
GFX_ANIM_SPLAT = 2
GFX_ANIM_ATTACK = 3
GFX_ANIM_BREATH = 4

; in:
; acoord = target coord
; x = color
; y = GFX_ANIM_x
gfx_animation:
    stx .gfx_animation_color
    lda tbl_gfx_anim_pos0,y
    sta .gfx_animation_pos0
    lda tbl_gfx_anim_pos1,y
    sta .gfx_animation_pos1
    jsr print_setup_dst_area
    ldy acoord
    ldx tbl_area_i_to_screen,y
.gfx_animation_color = * + 1
    lda #COLOR_BLUE
    sta colorram + POS_AREA,x
.gfx_animation_pos0 = * + 1
    ldy #4
-   lda .gfx_anim_all,y
    sta vmatrix + POS_AREA,x
    lda #4
    jsr delay
    dey
.gfx_animation_pos1 = * + 1
    cpy #0
    bne -
    ldy acoord
    jsr arena_draw_square
    rts

} ; !zn Gfx
